Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,9 +52,9 @@
 #define NAME "hdaudio"
 
-static errno_t hda_dev_add(ddf_dev_t *dev);
-static errno_t hda_dev_remove(ddf_dev_t *dev);
-static errno_t hda_dev_gone(ddf_dev_t *dev);
-static errno_t hda_fun_online(ddf_fun_t *fun);
-static errno_t hda_fun_offline(ddf_fun_t *fun);
+static int hda_dev_add(ddf_dev_t *dev);
+static int hda_dev_remove(ddf_dev_t *dev);
+static int hda_dev_gone(ddf_dev_t *dev);
+static int hda_fun_online(ddf_fun_t *fun);
+static int hda_fun_offline(ddf_fun_t *fun);
 
 static void hdaudio_interrupt(ipc_call_t *, ddf_dev_t *);
@@ -148,5 +148,5 @@
 };
 
-static errno_t hda_dev_add(ddf_dev_t *dev)
+static int hda_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun_pcm = NULL;
@@ -160,5 +160,5 @@
 	int i;
 	void *regs = NULL;
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_NOTE, "hda_dev_add()");
@@ -259,14 +259,14 @@
 	rc = hw_res_enable_interrupt(hda->parent_sess, res.irqs.irqs[0]);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed enabling interrupt.: %s", str_error(rc));
-		goto error;
-	}
-
-	int irq_cap;
-	rc = register_interrupt_handler(dev, res.irqs.irqs[0],
-	    hdaudio_interrupt, &irq_code, &irq_cap);
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed registering interrupt handler: %s",
-		    str_error_name(rc));
+		ddf_msg(LVL_ERROR, "Failed enabling interrupt. (%d)", rc);
+		goto error;
+	}
+
+	int irq_cap = register_interrupt_handler(dev, res.irqs.irqs[0],
+	    hdaudio_interrupt, &irq_code);
+	if (irq_cap < 0) {
+		rc = irq_cap;
+		ddf_msg(LVL_ERROR, "Failed registering interrupt handler. (%d)",
+		    rc);
 		goto error;
 	}
@@ -314,12 +314,12 @@
 	hw_res_list_parsed_clean(&res);
 
-	ddf_msg(LVL_NOTE, "Failing hda_dev_add() -> %s", str_error_name(rc));
+	ddf_msg(LVL_NOTE, "Failing hda_dev_add() -> %d", rc);
 	return rc;
 }
 
-static errno_t hda_dev_remove(ddf_dev_t *dev)
+static int hda_dev_remove(ddf_dev_t *dev)
 {
 	hda_t *hda = (hda_t *)ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "hda_dev_remove(%p)", dev);
@@ -340,8 +340,8 @@
 }
 
-static errno_t hda_dev_gone(ddf_dev_t *dev)
+static int hda_dev_gone(ddf_dev_t *dev)
 {
 	hda_t *hda = (hda_t *)ddf_dev_data_get(dev);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_DEBUG, "hda_dev_remove(%p)", dev);
@@ -356,5 +356,5 @@
 }
 
-static errno_t hda_fun_online(ddf_fun_t *fun)
+static int hda_fun_online(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "hda_fun_online()");
@@ -362,5 +362,5 @@
 }
 
-static errno_t hda_fun_offline(ddf_fun_t *fun)
+static int hda_fun_offline(ddf_fun_t *fun)
 {
 	ddf_msg(LVL_DEBUG, "hda_fun_offline()");
Index: uspace/drv/audio/hdaudio/pcm_iface.c
===================================================================
--- uspace/drv/audio/hdaudio/pcm_iface.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/hdaudio/pcm_iface.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,19 +47,19 @@
 #include "stream.h"
 
-static errno_t hda_get_info_str(ddf_fun_t *, const char **);
+static int hda_get_info_str(ddf_fun_t *, const char **);
 static unsigned hda_query_cap(ddf_fun_t *, audio_cap_t);
-static errno_t hda_test_format(ddf_fun_t *, unsigned *, unsigned *,
+static int hda_test_format(ddf_fun_t *, unsigned *, unsigned *,
     pcm_sample_format_t *);
-static errno_t hda_get_buffer(ddf_fun_t *, void **, size_t *);
-static errno_t hda_get_buffer_position(ddf_fun_t *, size_t *);
-static errno_t hda_set_event_session(ddf_fun_t *, async_sess_t *);
+static int hda_get_buffer(ddf_fun_t *, void **, size_t *);
+static int hda_get_buffer_position(ddf_fun_t *, size_t *);
+static int hda_set_event_session(ddf_fun_t *, async_sess_t *);
 static async_sess_t *hda_get_event_session(ddf_fun_t *);
-static errno_t hda_release_buffer(ddf_fun_t *);
-static errno_t hda_start_playback(ddf_fun_t *, unsigned, unsigned, unsigned,
+static int hda_release_buffer(ddf_fun_t *);
+static int hda_start_playback(ddf_fun_t *, unsigned, unsigned, unsigned,
     pcm_sample_format_t);
-static errno_t hda_stop_playback(ddf_fun_t *, bool);
-static errno_t hda_start_capture(ddf_fun_t *, unsigned, unsigned, unsigned,
+static int hda_stop_playback(ddf_fun_t *, bool);
+static int hda_start_capture(ddf_fun_t *, unsigned, unsigned, unsigned,
     pcm_sample_format_t);
-static errno_t hda_stop_capture(ddf_fun_t *, bool);
+static int hda_stop_capture(ddf_fun_t *, bool);
 
 audio_pcm_iface_t hda_pcm_iface = {
@@ -90,5 +90,5 @@
 }
 
-static errno_t hda_get_info_str(ddf_fun_t *fun, const char **name)
+static int hda_get_info_str(ddf_fun_t *fun, const char **name)
 {
 	ddf_msg(LVL_NOTE, "hda_get_info_str()");
@@ -120,12 +120,12 @@
 		return 16384;
 	default:
-		return -1;
-	}
-}
-
-static errno_t hda_test_format(ddf_fun_t *fun, unsigned *channels,
+		return ENOTSUP;
+	}
+}
+
+static int hda_test_format(ddf_fun_t *fun, unsigned *channels,
     unsigned *rate, pcm_sample_format_t *format)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	ddf_msg(LVL_NOTE, "hda_test_format(%u, %u, %d)\n",
@@ -150,8 +150,8 @@
 }
 
-static errno_t hda_get_buffer(ddf_fun_t *fun, void **buffer, size_t *size)
-{
-	hda_t *hda = fun_to_hda(fun);
-	errno_t rc;
+static int hda_get_buffer(ddf_fun_t *fun, void **buffer, size_t *size)
+{
+	hda_t *hda = fun_to_hda(fun);
+	int rc;
 
 	hda_lock(hda);
@@ -183,5 +183,5 @@
 }
 
-static errno_t hda_get_buffer_position(ddf_fun_t *fun, size_t *pos)
+static int hda_get_buffer_position(ddf_fun_t *fun, size_t *pos)
 {
 	ddf_msg(LVL_NOTE, "hda_get_buffer_position()");
@@ -189,5 +189,5 @@
 }
 
-static errno_t hda_set_event_session(ddf_fun_t *fun, async_sess_t *sess)
+static int hda_set_event_session(ddf_fun_t *fun, async_sess_t *sess)
 {
 	hda_t *hda = fun_to_hda(fun);
@@ -215,5 +215,5 @@
 }
 
-static errno_t hda_release_buffer(ddf_fun_t *fun)
+static int hda_release_buffer(ddf_fun_t *fun)
 {
 	hda_t *hda = fun_to_hda(fun);
@@ -234,9 +234,9 @@
 }
 
-static errno_t hda_start_playback(ddf_fun_t *fun, unsigned frames,
+static int hda_start_playback(ddf_fun_t *fun, unsigned frames,
     unsigned channels, unsigned rate, pcm_sample_format_t format)
 {
 	hda_t *hda = fun_to_hda(fun);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_NOTE, "hda_start_playback()");
@@ -275,5 +275,5 @@
 }
 
-static errno_t hda_stop_playback(ddf_fun_t *fun, bool immediate)
+static int hda_stop_playback(ddf_fun_t *fun, bool immediate)
 {
 	hda_t *hda = fun_to_hda(fun);
@@ -293,9 +293,9 @@
 }
 
-static errno_t hda_start_capture(ddf_fun_t *fun, unsigned frames, unsigned channels,
+static int hda_start_capture(ddf_fun_t *fun, unsigned frames, unsigned channels,
     unsigned rate, pcm_sample_format_t format)
 {
 	hda_t *hda = fun_to_hda(fun);
-	errno_t rc;
+	int rc;
 
 	ddf_msg(LVL_NOTE, "hda_start_capture()");
@@ -334,5 +334,5 @@
 }
 
-static errno_t hda_stop_capture(ddf_fun_t *fun, bool immediate)
+static int hda_stop_capture(ddf_fun_t *fun, bool immediate)
 {
 	hda_t *hda = fun_to_hda(fun);
Index: uspace/drv/audio/hdaudio/stream.c
===================================================================
--- uspace/drv/audio/hdaudio/stream.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/hdaudio/stream.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 #include <ddi.h>
 #include <errno.h>
-#include <str_error.h>
 #include <macros.h>
 #include <stdlib.h>
@@ -49,5 +48,5 @@
 #include "stream.h"
 
-errno_t hda_stream_buffers_alloc(hda_t *hda, hda_stream_buffers_t **rbufs)
+int hda_stream_buffers_alloc(hda_t *hda, hda_stream_buffers_t **rbufs)
 {
 	void *bdl;
@@ -57,5 +56,5 @@
 	size_t i;
 //	size_t j, k;
-	errno_t rc;
+	int rc;
 
 	bufs = calloc(1, sizeof(hda_stream_buffers_t));
@@ -123,5 +122,5 @@
 	    0, &buffer_phys, &buffer);
 	if (rc != EOK) {
-		ddf_msg(LVL_NOTE, "dmamem_map_anon -> %s", str_error_name(rc));
+		ddf_msg(LVL_NOTE, "dmamem_map_anon -> %d", rc);
 		goto error;
 	}
Index: uspace/drv/audio/hdaudio/stream.h
===================================================================
--- uspace/drv/audio/hdaudio/stream.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/hdaudio/stream.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -77,5 +77,5 @@
 } hda_stream_t;
 
-extern errno_t hda_stream_buffers_alloc(hda_t *, hda_stream_buffers_t **);
+extern int hda_stream_buffers_alloc(hda_t *, hda_stream_buffers_t **);
 extern void hda_stream_buffers_free(hda_stream_buffers_t *);
 extern hda_stream_t *hda_stream_create(hda_t *, hda_stream_dir_t,
Index: uspace/drv/audio/sb16/dsp.c
===================================================================
--- uspace/drv/audio/sb16/dsp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/dsp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -89,5 +89,5 @@
 }
 
-static inline errno_t dsp_read(sb_dsp_t *dsp, uint8_t *data)
+static inline int dsp_read(sb_dsp_t *dsp, uint8_t *data)
 {
 	assert(data);
@@ -106,5 +106,5 @@
 }
 
-static inline errno_t dsp_write(sb_dsp_t *dsp, uint8_t data)
+static inline int dsp_write(sb_dsp_t *dsp, uint8_t data)
 {
 	assert(dsp);
@@ -159,5 +159,5 @@
 }
 
-static inline errno_t setup_dma(sb_dsp_t *dsp, uintptr_t pa, size_t size)
+static inline int setup_dma(sb_dsp_t *dsp, uintptr_t pa, size_t size)
 {
 	async_sess_t *sess = ddf_dev_parent_sess_get(dsp->sb_dev);
@@ -168,5 +168,5 @@
 }
 
-static inline errno_t setup_buffer(sb_dsp_t *dsp, size_t size)
+static inline int setup_buffer(sb_dsp_t *dsp, size_t size)
 {
 	assert(dsp);
@@ -178,5 +178,5 @@
 	void *buffer = AS_AREA_ANY;
 	
-	errno_t ret = dmamem_map_anonymous(size, DMAMEM_16MiB | 0x0000ffff,
+	int ret = dmamem_map_anonymous(size, DMAMEM_16MiB | 0x0000ffff,
 	    AS_AREA_WRITE | AS_AREA_READ, 0, &pa, &buffer);
 	if (ret != EOK) {
@@ -202,5 +202,5 @@
 }
 
-errno_t sb_dsp_init(sb_dsp_t *dsp, sb16_regs_t *regs, ddf_dev_t *dev,
+int sb_dsp_init(sb_dsp_t *dsp, sb16_regs_t *regs, ddf_dev_t *dev,
     int dma8, int dma16)
 {
@@ -215,5 +215,5 @@
 	dsp_reset(dsp);
 	uint8_t response;
-	const errno_t ret = dsp_read(dsp, &response);
+	const int ret = dsp_read(dsp, &response);
 	if (ret != EOK) {
 		ddf_log_error("Failed to read DSP reset response value.");
@@ -290,9 +290,9 @@
 		return 16535;
 	default:
-		return -1;
-	}
-}
-
-errno_t sb_dsp_get_buffer_position(sb_dsp_t *dsp, size_t *pos)
+		return ENOTSUP;
+	}
+}
+
+int sb_dsp_get_buffer_position(sb_dsp_t *dsp, size_t *pos)
 {
 	if (dsp->state == DSP_NO_BUFFER)
@@ -303,16 +303,16 @@
 
 	// TODO: Assumes DMA 16
-	size_t remain;
-	errno_t rc = hw_res_dma_channel_remain(sess, dsp->dma16_channel, &remain);
-	if (rc == EOK) {
+	const int remain = hw_res_dma_channel_remain(sess, dsp->dma16_channel);
+	if (remain >= 0) {
 		*pos = dsp->buffer.size - remain;
-	}
-	return rc;
-}
-
-errno_t sb_dsp_test_format(sb_dsp_t *dsp, unsigned *channels, unsigned *rate,
+		return EOK;
+	}
+	return remain;
+}
+
+int sb_dsp_test_format(sb_dsp_t *dsp, unsigned *channels, unsigned *rate,
   pcm_sample_format_t *format)
 {
-	errno_t ret = EOK;
+	int ret = EOK;
 	if (*channels == 0 || *channels > 2) {
 		*channels = 2;
@@ -336,5 +336,5 @@
 }
 
-errno_t sb_dsp_set_event_session(sb_dsp_t *dsp, async_sess_t *session)
+int sb_dsp_set_event_session(sb_dsp_t *dsp, async_sess_t *session)
 {
 	assert(dsp);
@@ -353,5 +353,5 @@
 }
 
-errno_t sb_dsp_get_buffer(sb_dsp_t *dsp, void **buffer, size_t *size)
+int sb_dsp_get_buffer(sb_dsp_t *dsp, void **buffer, size_t *size)
 {
 	assert(dsp);
@@ -364,5 +364,5 @@
 	assert(dsp->buffer.data == NULL);
 
-	const errno_t ret = setup_buffer(dsp, *size);
+	const int ret = setup_buffer(dsp, *size);
 	if (ret == EOK) {
 		ddf_log_debug("Providing buffer: %p, %zu B.",
@@ -378,5 +378,5 @@
 }
 
-errno_t sb_dsp_release_buffer(sb_dsp_t *dsp)
+int sb_dsp_release_buffer(sb_dsp_t *dsp)
 {
 	assert(dsp);
@@ -392,5 +392,5 @@
 }
 
-errno_t sb_dsp_start_playback(sb_dsp_t *dsp, unsigned frames,
+int sb_dsp_start_playback(sb_dsp_t *dsp, unsigned frames,
     unsigned channels, unsigned sampling_rate, pcm_sample_format_t format)
 {
@@ -441,5 +441,5 @@
 }
 
-errno_t sb_dsp_stop_playback(sb_dsp_t *dsp, bool immediate)
+int sb_dsp_stop_playback(sb_dsp_t *dsp, bool immediate)
 {
 	assert(dsp);
@@ -471,5 +471,5 @@
 }
 
-errno_t sb_dsp_start_capture(sb_dsp_t *dsp, unsigned frames,
+int sb_dsp_start_capture(sb_dsp_t *dsp, unsigned frames,
     unsigned channels, unsigned sampling_rate, pcm_sample_format_t format)
 {
@@ -517,5 +517,5 @@
 }
 
-errno_t sb_dsp_stop_capture(sb_dsp_t *dsp, bool immediate)
+int sb_dsp_stop_capture(sb_dsp_t *dsp, bool immediate)
 {
 	assert(dsp);
Index: uspace/drv/audio/sb16/dsp.h
===================================================================
--- uspace/drv/audio/sb16/dsp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/dsp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -76,21 +76,21 @@
 } sb_dsp_t;
 
-errno_t sb_dsp_init(sb_dsp_t *dsp, sb16_regs_t *regs, ddf_dev_t *dev,
+int sb_dsp_init(sb_dsp_t *dsp, sb16_regs_t *regs, ddf_dev_t *dev,
     int dma8, int dma16);
 void sb_dsp_interrupt(sb_dsp_t *dsp);
 unsigned sb_dsp_query_cap(sb_dsp_t *dsp, audio_cap_t cap);
-errno_t sb_dsp_get_buffer_position(sb_dsp_t *dsp, size_t *size);
-errno_t sb_dsp_test_format(sb_dsp_t *dsp, unsigned *channels, unsigned *rate,
-    pcm_sample_format_t *format);
-errno_t sb_dsp_get_buffer(sb_dsp_t *dsp, void **buffer, size_t *size);
-errno_t sb_dsp_set_event_session(sb_dsp_t *dsp, async_sess_t *session);
-async_sess_t *sb_dsp_get_event_session(sb_dsp_t *dsp);
-errno_t sb_dsp_release_buffer(sb_dsp_t *dsp);
-errno_t sb_dsp_start_playback(sb_dsp_t *dsp, unsigned frames,
+int sb_dsp_get_buffer_position(sb_dsp_t *dsp, size_t *size);
+int sb_dsp_test_format(sb_dsp_t *dsp, unsigned *channels, unsigned *rate,
+  pcm_sample_format_t *format);
+int sb_dsp_get_buffer(sb_dsp_t *dsp, void **buffer, size_t *size);
+int sb_dsp_set_event_session(sb_dsp_t *dsp, async_sess_t *session);
+async_sess_t * sb_dsp_get_event_session(sb_dsp_t *dsp);
+int sb_dsp_release_buffer(sb_dsp_t *dsp);
+int sb_dsp_start_playback(sb_dsp_t *dsp, unsigned frames,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format);
-errno_t sb_dsp_stop_playback(sb_dsp_t *dsp, bool immediate);
-errno_t sb_dsp_start_capture(sb_dsp_t *dsp, unsigned frames,
+int sb_dsp_stop_playback(sb_dsp_t *dsp, bool immediate);
+int sb_dsp_start_capture(sb_dsp_t *dsp, unsigned frames,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format);
-errno_t sb_dsp_stop_capture(sb_dsp_t *dsp, bool immediate);
+int sb_dsp_stop_capture(sb_dsp_t *dsp, bool immediate);
 
 #endif
Index: uspace/drv/audio/sb16/main.c
===================================================================
--- uspace/drv/audio/sb16/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,8 +47,8 @@
 #define NAME "sb16"
 
-static errno_t sb_add_device(ddf_dev_t *device);
-static errno_t sb_get_res(ddf_dev_t *device, addr_range_t **pp_sb_regs,
+static int sb_add_device(ddf_dev_t *device);
+static int sb_get_res(ddf_dev_t *device, addr_range_t **pp_sb_regs,
     addr_range_t **pp_mpu_regs, int *irq, int *dma8, int *dma16);
-static errno_t sb_enable_interrupt(ddf_dev_t *device, int irq);
+static int sb_enable_interrupt(ddf_dev_t *device, int irq);
 
 static driver_ops_t sb_driver_ops = {
@@ -87,5 +87,5 @@
  * @return Error code.
  */
-static errno_t sb_add_device(ddf_dev_t *device)
+static int sb_add_device(ddf_dev_t *device)
 {
 	bool handler_regd = false;
@@ -96,5 +96,5 @@
 
 	sb16_t *soft_state = ddf_dev_data_alloc(device, sizeof(sb16_t));
-	errno_t rc = soft_state ? EOK : ENOMEM;
+	int rc = soft_state ? EOK : ENOMEM;
 	if (rc != EOK) {
 		ddf_log_error("Failed to allocate sb16 structure.");
@@ -123,7 +123,8 @@
 	};
 
-	rc = register_interrupt_handler(device, irq, irq_handler,
-	    &irq_code, &irq_cap);
-	if (rc != EOK) {
+	irq_cap = register_interrupt_handler(device, irq, irq_handler,
+	    &irq_code);
+	if (irq_cap < 0) {
+		rc = irq_cap;
 		ddf_log_error("Failed to register irq handler: %s.",
 		    str_error(rc));
@@ -173,5 +174,5 @@
 }
 
-static errno_t sb_get_res(ddf_dev_t *device, addr_range_t **pp_sb_regs,
+static int sb_get_res(ddf_dev_t *device, addr_range_t **pp_sb_regs,
     addr_range_t **pp_mpu_regs, int *irq, int *dma8, int *dma16)
 {
@@ -184,5 +185,5 @@
 	hw_res_list_parsed_t hw_res;
 	hw_res_list_parsed_init(&hw_res);
-	const errno_t ret = hw_res_get_list_parsed(parent_sess, &hw_res, 0);
+	const int ret = hw_res_get_list_parsed(parent_sess, &hw_res, 0);
 	if (ret != EOK) {
 		return ret;
@@ -241,5 +242,5 @@
 }
 
-static errno_t sb_enable_interrupt(ddf_dev_t *device, int irq)
+static int sb_enable_interrupt(ddf_dev_t *device, int irq)
 {
 	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
Index: uspace/drv/audio/sb16/mixer.c
===================================================================
--- uspace/drv/audio/sb16/mixer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/mixer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -123,5 +123,5 @@
 }
 
-errno_t sb_mixer_init(sb_mixer_t *mixer, sb16_regs_t *regs, sb_mixer_type_t type)
+int sb_mixer_init(sb_mixer_t *mixer, sb16_regs_t *regs, sb_mixer_type_t type)
 {
 	assert(mixer);
@@ -149,5 +149,5 @@
 }
 
-errno_t sb_mixer_get_control_item_info(const sb_mixer_t *mixer, unsigned item,
+int sb_mixer_get_control_item_info(const sb_mixer_t *mixer, unsigned item,
     const char** name, unsigned *levels)
 {
@@ -171,5 +171,5 @@
  * @return Error code.
  */
-errno_t sb_mixer_get_control_item_value(const sb_mixer_t *mixer, unsigned item,
+int sb_mixer_get_control_item_value(const sb_mixer_t *mixer, unsigned item,
     unsigned *value)
 {
@@ -194,5 +194,5 @@
  * @return Error code.
  */
-errno_t sb_mixer_set_control_item_value(const sb_mixer_t *mixer, unsigned item,
+int sb_mixer_set_control_item_value(const sb_mixer_t *mixer, unsigned item,
     unsigned value)
 {
Index: uspace/drv/audio/sb16/mixer.h
===================================================================
--- uspace/drv/audio/sb16/mixer.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/mixer.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,12 +50,12 @@
 } sb_mixer_t;
 
-const char *sb_mixer_type_str(sb_mixer_type_t type);
-errno_t sb_mixer_init(sb_mixer_t *mixer, sb16_regs_t *regs, sb_mixer_type_t type);
+const char * sb_mixer_type_str(sb_mixer_type_t type);
+int sb_mixer_init(sb_mixer_t *mixer, sb16_regs_t *regs, sb_mixer_type_t type);
 int sb_mixer_get_control_item_count(const sb_mixer_t *mixer);
-errno_t sb_mixer_get_control_item_info(const sb_mixer_t *mixer, unsigned index,
+int sb_mixer_get_control_item_info(const sb_mixer_t *mixer, unsigned index,
     const char **name, unsigned *levels);
-errno_t sb_mixer_get_control_item_value(const sb_mixer_t *mixer, unsigned index,
+int sb_mixer_get_control_item_value(const sb_mixer_t *mixer, unsigned index,
     unsigned *value);
-errno_t sb_mixer_set_control_item_value(const sb_mixer_t *mixer, unsigned index,
+int sb_mixer_set_control_item_value(const sb_mixer_t *mixer, unsigned index,
     unsigned value);
 #endif
Index: uspace/drv/audio/sb16/mixer_iface.c
===================================================================
--- uspace/drv/audio/sb16/mixer_iface.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/mixer_iface.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,5 +46,5 @@
 }
 
-static errno_t sb_get_info(ddf_fun_t *fun, const char** name, unsigned *items)
+static int sb_get_info(ddf_fun_t *fun, const char** name, unsigned *items)
 {
 	sb_mixer_t *mixer = fun_to_mixer(fun);
@@ -58,5 +58,5 @@
 }
 
-static errno_t sb_get_item_info(ddf_fun_t *fun, unsigned item, const char** name,
+static int sb_get_item_info(ddf_fun_t *fun, unsigned item, const char** name,
     unsigned *max_level)
 {
@@ -65,5 +65,5 @@
 }
 
-static errno_t sb_set_item_level(ddf_fun_t *fun, unsigned item, unsigned value)
+static int sb_set_item_level(ddf_fun_t *fun, unsigned item, unsigned value)
 {
 	sb_mixer_t *mixer = fun_to_mixer(fun);
@@ -71,5 +71,5 @@
 }
 
-static errno_t sb_get_item_level(ddf_fun_t *fun, unsigned item, unsigned *value)
+static int sb_get_item_level(ddf_fun_t *fun, unsigned item, unsigned *value)
 {
 	sb_mixer_t *mixer = fun_to_mixer(fun);
Index: uspace/drv/audio/sb16/pcm_iface.c
===================================================================
--- uspace/drv/audio/sb16/pcm_iface.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/pcm_iface.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,5 @@
 }
 
-static errno_t sb_get_info_str(ddf_fun_t *fun, const char** name)
+static int sb_get_info_str(ddf_fun_t *fun, const char** name)
 {
 	if (name)
@@ -59,20 +59,20 @@
 }
 
-static errno_t sb_test_format(ddf_fun_t *fun, unsigned *channels, unsigned *rate,
+static int sb_test_format(ddf_fun_t *fun, unsigned *channels, unsigned *rate,
     pcm_sample_format_t *format)
 {
 	return sb_dsp_test_format(fun_to_dsp(fun), channels, rate, format);
 }
-static errno_t sb_get_buffer(ddf_fun_t *fun, void **buffer, size_t *size)
+static int sb_get_buffer(ddf_fun_t *fun, void **buffer, size_t *size)
 {
 	return sb_dsp_get_buffer(fun_to_dsp(fun), buffer, size);
 }
 
-static errno_t sb_get_buffer_position(ddf_fun_t *fun, size_t *size)
+static int sb_get_buffer_position(ddf_fun_t *fun, size_t *size)
 {
 	return sb_dsp_get_buffer_position(fun_to_dsp(fun), size);
 }
 
-static errno_t sb_set_event_session(ddf_fun_t *fun, async_sess_t *sess)
+static int sb_set_event_session(ddf_fun_t *fun, async_sess_t *sess)
 {
 	return sb_dsp_set_event_session(fun_to_dsp(fun), sess);
@@ -84,10 +84,10 @@
 }
 
-static errno_t sb_release_buffer(ddf_fun_t *fun)
+static int sb_release_buffer(ddf_fun_t *fun)
 {
 	return sb_dsp_release_buffer(fun_to_dsp(fun));
 }
 
-static errno_t sb_start_playback(ddf_fun_t *fun, unsigned frames,
+static int sb_start_playback(ddf_fun_t *fun, unsigned frames,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format)
 {
@@ -96,10 +96,10 @@
 }
 
-static errno_t sb_stop_playback(ddf_fun_t *fun, bool immediate)
+static int sb_stop_playback(ddf_fun_t *fun, bool immediate)
 {
 	return sb_dsp_stop_playback(fun_to_dsp(fun), immediate);
 }
 
-static errno_t sb_start_capture(ddf_fun_t *fun, unsigned frames,
+static int sb_start_capture(ddf_fun_t *fun, unsigned frames,
     unsigned channels, unsigned sample_rate, pcm_sample_format_t format)
 {
@@ -108,5 +108,5 @@
 }
 
-static errno_t sb_stop_capture(ddf_fun_t *fun, bool immediate)
+static int sb_stop_capture(ddf_fun_t *fun, bool immediate)
 {
 	return sb_dsp_stop_capture(fun_to_dsp(fun), immediate);
Index: uspace/drv/audio/sb16/sb16.c
===================================================================
--- uspace/drv/audio/sb16/sb16.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/sb16.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -94,5 +94,5 @@
 }
 
-errno_t sb16_init_sb16(sb16_t *sb, addr_range_t *regs, ddf_dev_t *dev, int dma8,
+int sb16_init_sb16(sb16_t *sb, addr_range_t *regs, ddf_dev_t *dev, int dma8,
     int dma16)
 {
@@ -100,5 +100,5 @@
 
 	/* Setup registers */
-	errno_t ret = pio_enable_range(regs, (void **) &sb->regs);
+	int ret = pio_enable_range(regs, (void **) &sb->regs);
 	if (ret != EOK)
 		return ret;
@@ -179,5 +179,5 @@
 }
 
-errno_t sb16_init_mpu(sb16_t *sb, addr_range_t *regs)
+int sb16_init_mpu(sb16_t *sb, addr_range_t *regs)
 {
 	sb->mpu_regs = NULL;
Index: uspace/drv/audio/sb16/sb16.h
===================================================================
--- uspace/drv/audio/sb16/sb16.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/audio/sb16/sb16.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,6 +53,6 @@
 size_t sb16_irq_code_size(void);
 void sb16_irq_code(addr_range_t *regs, int dma8, int dma16, irq_cmd_t cmds[], irq_pio_range_t ranges[]);
-errno_t sb16_init_sb16(sb16_t *sb, addr_range_t *regs, ddf_dev_t *dev, int dma8, int dma16);
-errno_t sb16_init_mpu(sb16_t *sb, addr_range_t *regs);
+int sb16_init_sb16(sb16_t *sb, addr_range_t *regs, ddf_dev_t *dev, int dma8, int dma16);
+int sb16_init_mpu(sb16_t *sb, addr_range_t *regs);
 void sb16_interrupt(sb16_t *sb);
 
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/drv/block/ahci/ahci.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -109,14 +109,14 @@
 	}
 
-static errno_t get_sata_device_name(ddf_fun_t *, size_t, char *);
-static errno_t get_num_blocks(ddf_fun_t *, uint64_t *);
-static errno_t get_block_size(ddf_fun_t *, size_t *);
-static errno_t read_blocks(ddf_fun_t *, uint64_t, size_t, void *);
-static errno_t write_blocks(ddf_fun_t *, uint64_t, size_t, void *);
-
-static errno_t ahci_identify_device(sata_dev_t *);
-static errno_t ahci_set_highest_ultra_dma_mode(sata_dev_t *);
-static errno_t ahci_rb_fpdma(sata_dev_t *, uintptr_t, uint64_t);
-static errno_t ahci_wb_fpdma(sata_dev_t *, uintptr_t, uint64_t);
+static int get_sata_device_name(ddf_fun_t *, size_t, char *);
+static int get_num_blocks(ddf_fun_t *, uint64_t *);
+static int get_block_size(ddf_fun_t *, size_t *);
+static int read_blocks(ddf_fun_t *, uint64_t, size_t, void *);
+static int write_blocks(ddf_fun_t *, uint64_t, size_t, void *);
+
+static int ahci_identify_device(sata_dev_t *);
+static int ahci_set_highest_ultra_dma_mode(sata_dev_t *);
+static int ahci_rb_fpdma(sata_dev_t *, uintptr_t, uint64_t);
+static int ahci_wb_fpdma(sata_dev_t *, uintptr_t, uint64_t);
 
 static void ahci_sata_devices_create(ahci_dev_t *, ddf_dev_t *);
@@ -124,5 +124,5 @@
 static void ahci_ahci_hw_start(ahci_dev_t *);
 
-static errno_t ahci_dev_add(ddf_dev_t *);
+static int ahci_dev_add(ddf_dev_t *);
 
 static void ahci_get_model_name(uint16_t *, char *);
@@ -177,5 +177,5 @@
  *
  */
-static errno_t get_sata_device_name(ddf_fun_t *fun,
+static int get_sata_device_name(ddf_fun_t *fun,
     size_t sata_dev_name_length, char *sata_dev_name)
 {
@@ -193,5 +193,5 @@
  *
  */
-static errno_t get_num_blocks(ddf_fun_t *fun, uint64_t *num_blocks)
+static int get_num_blocks(ddf_fun_t *fun, uint64_t *num_blocks)
 {
 	sata_dev_t *sata = fun_sata_dev(fun);
@@ -208,5 +208,5 @@
  *
  */
-static errno_t get_block_size(ddf_fun_t *fun, size_t *block_size)
+static int get_block_size(ddf_fun_t *fun, size_t *block_size)
 {
 	sata_dev_t *sata = fun_sata_dev(fun);
@@ -225,5 +225,5 @@
  *
  */
-static errno_t read_blocks(ddf_fun_t *fun, uint64_t blocknum,
+static int read_blocks(ddf_fun_t *fun, uint64_t blocknum,
     size_t count, void *buf)
 {
@@ -232,5 +232,5 @@
 	uintptr_t phys;
 	void *ibuf = AS_AREA_ANY;
-	errno_t rc = dmamem_map_anonymous(sata->block_size, DMAMEM_4GiB,
+	int rc = dmamem_map_anonymous(sata->block_size, DMAMEM_4GiB,
 	    AS_AREA_READ | AS_AREA_WRITE, 0, &phys, &ibuf);
 	if (rc != EOK) {
@@ -268,5 +268,5 @@
  *
  */
-static errno_t write_blocks(ddf_fun_t *fun, uint64_t blocknum,
+static int write_blocks(ddf_fun_t *fun, uint64_t blocknum,
     size_t count, void *buf)
 {
@@ -275,5 +275,5 @@
 	uintptr_t phys;
 	void *ibuf = AS_AREA_ANY;
-	errno_t rc = dmamem_map_anonymous(sata->block_size, DMAMEM_4GiB,
+	int rc = dmamem_map_anonymous(sata->block_size, DMAMEM_4GiB,
 	    AS_AREA_READ | AS_AREA_WRITE, 0, &phys, &ibuf);
 	if (rc != EOK) {
@@ -424,5 +424,5 @@
  *
  */
-static errno_t ahci_identify_device(sata_dev_t *sata)
+static int ahci_identify_device(sata_dev_t *sata)
 {
 	if (sata->is_invalid_device) {
@@ -434,5 +434,5 @@
 	uintptr_t phys;
 	sata_identify_data_t *idata = AS_AREA_ANY;
-	errno_t rc = dmamem_map_anonymous(SATA_IDENTIFY_DEVICE_BUFFER_LENGTH,
+	int rc = dmamem_map_anonymous(SATA_IDENTIFY_DEVICE_BUFFER_LENGTH,
 	    DMAMEM_4GiB, AS_AREA_READ | AS_AREA_WRITE, 0, &phys,
 	    (void *) &idata);
@@ -605,5 +605,5 @@
  *
  */
-static errno_t ahci_set_highest_ultra_dma_mode(sata_dev_t *sata)
+static int ahci_set_highest_ultra_dma_mode(sata_dev_t *sata)
 {
 	if (sata->is_invalid_device) {
@@ -628,5 +628,5 @@
 	uintptr_t phys;
 	sata_identify_data_t *idata = AS_AREA_ANY;
-	errno_t rc = dmamem_map_anonymous(SATA_SET_FEATURE_BUFFER_LENGTH,
+	int rc = dmamem_map_anonymous(SATA_SET_FEATURE_BUFFER_LENGTH,
 	    DMAMEM_4GiB, AS_AREA_READ | AS_AREA_WRITE, 0, &phys,
 	    (void *) &idata);
@@ -734,5 +734,5 @@
  *
  */
-static errno_t ahci_rb_fpdma(sata_dev_t *sata, uintptr_t phys, uint64_t blocknum)
+static int ahci_rb_fpdma(sata_dev_t *sata, uintptr_t phys, uint64_t blocknum)
 {
 	if (sata->is_invalid_device) {
@@ -822,5 +822,5 @@
  *
  */
-static errno_t ahci_wb_fpdma(sata_dev_t *sata, uintptr_t phys, uint64_t blocknum)
+static int ahci_wb_fpdma(sata_dev_t *sata, uintptr_t phys, uint64_t blocknum)
 {
 	if (sata->is_invalid_device) {
@@ -949,5 +949,5 @@
 	
 	/* Allocate and init retfis structure. */
-	errno_t rc = dmamem_map_anonymous(size, DMAMEM_4GiB,
+	int rc = dmamem_map_anonymous(size, DMAMEM_4GiB,
 	    AS_AREA_READ | AS_AREA_WRITE, 0, &phys, &virt_fb);
 	if (rc != EOK)
@@ -1038,9 +1038,9 @@
  *
  */
-static errno_t ahci_sata_create(ahci_dev_t *ahci, ddf_dev_t *dev,
+static int ahci_sata_create(ahci_dev_t *ahci, ddf_dev_t *dev,
     volatile ahci_port_t *port, unsigned int port_num)
 {
 	ddf_fun_t *fun = NULL;
-	errno_t rc;
+	int rc;
 	
 	sata_dev_t *sata = ahci_sata_allocate(ahci, port);
@@ -1184,13 +1184,12 @@
 	ct.ranges = ahci_ranges;
 	
-	int irq_cap;
-	errno_t rc = register_interrupt_handler(dev,
-	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct, &irq_cap);
-	if (rc != EOK) {
+	int irq_cap = register_interrupt_handler(dev,
+	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct);
+	if (irq_cap < 0) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler.");
 		goto error_register_interrupt_handler;
 	}
 	
-	rc = hw_res_enable_interrupt(ahci->parent_sess,
+	int rc = hw_res_enable_interrupt(ahci->parent_sess,
 	    hw_res_parsed.irqs.irqs[0]);
 	if (rc != EOK) {
@@ -1255,5 +1254,5 @@
  *
  */
-static errno_t ahci_dev_add(ddf_dev_t *dev)	
+static int ahci_dev_add(ddf_dev_t *dev)	
 {
 	ahci_dev_t *ahci = ahci_ahci_create(dev);
